//+------------------------------------------------------------------+
//|                                                      Another.mq4 |
//|                                         Copyright 2012, BowForex |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, BowForex"
#property link      "http://www.bowfx.zente.org (hungarian language)"

extern int magic = 11220;

extern string str0 = "Take profit pips";  
extern int TP = 20;
extern string str1 = "Stop loss pips";  
extern int SL = 20;
extern string str2 = "BE turn on pips";
extern int BE = 12;
extern string str3 = "Lot size";  
extern double LS = 0.02;

extern string str4 = "TP Line Color";  
extern color TPLineColor = LightGreen;




#import "mt4gui.dll"   
   string tbVersion();       
   
   // objects "button","checkbox","list","label","text"
   int tbPutObject(int,string,int,int,int,int,string); // hwnd,type,x,y,w,h,label   
   
   // colors
   int tbSetBgColor(int,int,int); // hwnd,object,bgcolor
   int tbSetTextColor(int,int,int); // hwnd,object,color
   
   // removing objects
   int tbRemove(int,int);  // hwnd,handle
   int tbRemoveAll(int); // hwnd
   
   // events
   bool tbIsClicked( int,int ); // hwnd,object
   bool tbIsChecked(int,int); // hwnd,object
   // properties
   int tbSetText(int,int,string,int,string); // hwnd,object,text,fontsize,fontname   
   string tbGetText(int,int); // hwnd,object   
   int tbSetChecked(int,int,bool); // hwnd,object,true|false      
   int tbEnable(int,int,int); // hwnd, object, 0|1   
   
   // listbox 
   int tbAddListItem(int,int,string); // hwnd,object,item
   int tbGetListSel(int,int); // hwnd,object
   int tbSetListSel(int,int,int); // hwnd,object,index
   
   
   
   
#import
//----
#include <libvisual.mqh>

int SellBtn, BuyBtn, PanicBtn, ForceClose;

int gombkint=0;
int stat = 0;




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
         
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      int hwnd=WindowHandle(Symbol(),Period());
      tbRemoveAll(hwnd); ObjectsDeleteAll();
      Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   string comm = "";
//----
      comm = comm + vezerlo();
      comm = comm + "Another simple system assistant";
      
      if (gombkint == 0) gombok();
      Comment(comm);
//----
   return(0);
  }
//+------------------------------------------------------------------+
string vezerlo() {
      int hwnd=WindowHandle(Symbol(),Period()); pReset();
      int totalO=OrdersTotal();
      int cntO, CloseTotal; 
      
      if (ForceClose == 1) {
         
            
         for(cntO=0;cntO<totalO;cntO++)
            {
               OrderSelect(cntO, SELECT_BY_POS, MODE_TRADES);
               if(OrderSymbol()==Symbol())  
               {
                  
                  if (OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid, 3,White);
                  if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask, 3,White);
                  
                  
               }
            }
            ForceClose = 0;
          
      }
      
      
      double LotSizes=MarketInfo(Symbol(),MODE_LOTSIZE) / AccountLeverage();
      double MinLots=MarketInfo(Symbol(),MODE_MINLOT);
      double MaxLot=MarketInfo(Symbol(),MODE_MAXLOT);
      double LotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
      double PipSize=MarketInfo(Symbol(),MODE_TICKVALUE);
      int TradeAllowed=MarketInfo(Symbol(),MODE_TRADEALLOWED);
      double Slippage=MarketInfo(Symbol(),MODE_SPREAD);
      double Digit=MarketInfo(Symbol(),MODE_DIGITS);
      double RequiredMargin=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
      
      string calc = "";
      
      
      
      int mod;
      if (Digits == 5 || Digits == 3) {
         mod = 10;
      }
      if (Digits == 4 ) {
         mod = 1;
      }
      if (Digits == 6 ) {
         mod = 100;
      }
      int isOpenOrder = 0;
      double TPLineNow = NormalizeDouble( ObjectGet("TPLine",OBJPROP_PRICE1),Digits);
      // BE setting, TP Line lisenter
      for(cntO=0;cntO<totalO;cntO++)
            {
               OrderSelect(cntO, SELECT_BY_POS, MODE_TRADES);
               if(OrderSymbol()==Symbol())  
               {
                  isOpenOrder = 1;
                  
                  if (OrderType()==OP_BUY) {
                     if ((OrderOpenPrice()+BE*Point*mod)>= Ask ) {
                        // price maked right movment
                        if (OrderTakeProfit() < (Ask+BE*Point*mod)) {
                           OrderModify(OrderTicket(), OrderOpenPrice(),OrderOpenPrice(), OrderTakeProfit(),0,Blue); 
                        }
                     }
                   
                      
                  }
                  if (OrderType()==OP_SELL) {
                     calc = calc + "\nBEE: "+ (Bid-(OrderOpenPrice()-BE*Point*mod));
                     if (Bid-(OrderOpenPrice()-BE*Point*mod) < 0 ) {
                        // price maked right movment
                        if (OrderTakeProfit() > (Bid-BE*Point*mod)) {
                           OrderModify(OrderTicket(), OrderOpenPrice(),OrderOpenPrice(), OrderTakeProfit(),0,Blue); 
                        }
                     }
                  }
                  if (OrderTakeProfit() != TPLineNow) {
                     OrderModify(OrderTicket(), OrderOpenPrice(),OrderStopLoss(), TPLineNow,0,Green);
                   }
                  
                  
               }
            }
      double TPnow;
      if(tbIsClicked(hwnd,BuyBtn)) {
         stat = 1; 
         
         TPnow = (Ask+TP*Point*mod);
         
         if (isOpenOrder==1) {
            // if we have open order(s), modify the previosly's take profit's
            for(cntO=0;cntO<totalO;cntO++)
            {
               OrderSelect(cntO, SELECT_BY_POS, MODE_TRADES);
               if(OrderSymbol()==Symbol())  
               {
                  
                  
                  if (OrderType()==OP_BUY) {
                     OrderModify(OrderTicket(), OrderOpenPrice(),OrderStopLoss(), TPnow,0,Blue);  
                  }
                 
                  
                  
                  }
               }
         }
         
         OrderSend(Symbol(),OP_BUY,LS,Ask,3,(Bid-SL*Point*mod),TPnow,"BUY ORDER",3,NULL,Red);
         
         ObjectCreate("TPLine",OBJ_HLINE,NULL,NULL,TPnow );
         ObjectSet("TPLine",OBJPROP_COLOR,TPLineColor);
         ObjectSet("TPLine",OBJPROP_PRICE1,TPnow);
         
         
            
      }
      
      if(tbIsClicked(hwnd,SellBtn)) {
         stat = 2;  
         
         
         TPnow = (Bid-TP*Point*mod);
         
         if (isOpenOrder==1) {
            // if we have open order(s), modify the previosly's take profit's
            for(cntO=0;cntO<totalO;cntO++)
            {
               OrderSelect(cntO, SELECT_BY_POS, MODE_TRADES);
               if(OrderSymbol()==Symbol())  
               {
                  
                  
                  if (OrderType()==OP_SELL) {
                     OrderModify(OrderTicket(), OrderOpenPrice(),OrderStopLoss(), TPnow,0,Blue);  
                  }
                 
                  
                  
                  }
               }
         }
         
         OrderSend(Symbol(),OP_SELL,LS,Bid,3,(Ask+SL*Point*mod),TPnow, "SELL ORDER",3,NULL,Red);
         ObjectCreate("TPLine",OBJ_HLINE,NULL,NULL,TPnow );
         ObjectSet("TPLine",OBJPROP_COLOR,TPLineColor);
         ObjectSet("TPLine",OBJPROP_PRICE1,TPnow);
         
         
         
      }
      
      
      if(tbIsClicked(hwnd,PanicBtn)) {
         
         
         ForceClose = 1;
      }
      return (calc);
      
      
}
int gombok() {
      int hwnd=WindowHandle(Symbol(),Period());
      int x=200,y=10,w=120,h=40,dis=15;
      tbRemoveAll(hwnd);
      gombkint = 1;
      
      // gombok
               
      BuyBtn=tbPutObject(hwnd,"button",x,y,40,h,"Buy");x=x+40+dis;
      tbSetBgColor(hwnd,BuyBtn,Lime); tbSetTextColor(hwnd,BuyBtn,Black);
      
      SellBtn=tbPutObject(hwnd,"button",x,y,40,h,"Sell");x=x+40+dis;
      tbSetBgColor(hwnd,SellBtn,Red); tbSetTextColor(hwnd,SellBtn,Black);
      
      PanicBtn=tbPutObject(hwnd,"button",x,y,70,h,"Panic");x=x+70+dis;
      tbSetBgColor(hwnd,PanicBtn,DarkBlue); tbSetTextColor(hwnd,PanicBtn,White);
      
  }
  